% stri='3000.mtx';
% A=mmread(stri);
A=getMatrix(500, 'f', 1 ,10,100);
b=ones(length(A),1);
restrt=100;
max_it=100;
tol=1e-4;


% Do GMERS with SAI Preconditioner
M = sai(A,A);
afun = @(x) A*(M*x);
x = gmres(afun,b,restrt,tol,max_it);
%x = M*x



% Do ILU
% L=tril(A);
% U=triu(A);
% for i=0:50
%     if mod(i,2)==0
%         U=sai(L,U,A);
%     else
%         L=sai(transpose(U),transpose(L),transpose(A));
%         L=transpose(L);
%     end
%     fprintf('Frobenius norm of matrix is: %f\n', norm(L*U-A,'fro'))
% end

% Do ILU
setup.type = 'nofill';
[L,U] = ilu(A,setup);

% Do GMRES with ILU Preconditioner
x = gmres(A,b,restrt,tol,max_it,L,U);

%x=zeros(length(A),1);
%M=L*U;
% [x, error, iter, flag] = gmres_left( A, x, b, L, U, restrt, max_it, tol );
% if flag
%     fprintf('GMRES did not converge after %i steps. The error is %f\n', iter, error)
% else
%     fprintf('GMRES did converge after %i steps. The error is %f\n', iter, error)
% end

% L_from_c=mmread('L.mtx');
% L_pre_from_c=mmread('L_PRECONDITIONER.mtx');
% L_pre=sai_IisJ(L,L);
% 
% norm(L-L_from_c,1)
% norm(L_pre-L_pre_from_c,1)
% 
% 
% % Do Jacobi
% eps=1e-6;
% maxsteps=1000;
% L_pre=sai_IisJ(L,L);
% %L_pre=sai(L,L);
% U_pre=sai_IisJ(U,U);
% %U_pre=sai(U,U);
% y=Jacobi(L,L_pre,b,eps,maxsteps);
% x=Jacobi(U,U_pre,y,eps,maxsteps);
% fprintf('Frobenius norm of LUx-b is : %f\n', norm(L*U*x-b,1))
